﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace sampleApp
{
    public partial class Form1 : Form
    {
        private bool processFlg = false;
        private bool closeFlg = false;
        public Form1()
        {
            InitializeComponent();
            this.ultraPanel1.Hide();
            this.ultraGrid1.Hide();
        }
        // START PREVIEW
        private void button2_Click(object sender, EventArgs e)
        {
            this.processFlg = true;
            this.button2.Enabled = false;
            this.ultraPanel1.Show();
            this.ultraProgressBar1.Maximum = 105;
            this.ultraLabel1.Text = "previewing .....";

            DataBind();
            SetProcessBar(5);
            if (this.closeFlg)
            {
                this.Dispose();
                return;
            }
            InitializePrintPreviewControl();
        }
        // CLOSE WINDOW
        private void button1_Click(object sender, EventArgs e)
        {
            if (this.processFlg)
            {
                DialogResult result = MessageBox.Show("Are you sure to close the window?", "confirm", MessageBoxButtons.YesNo, MessageBoxIcon.Question);
                if (result == DialogResult.Yes)
                {
                    this.closeFlg = true;
                    return;
                }
            }
            this.Close();
        }
        private void DataBind()
        {
            DataTable dt = new DataTable();
            dt.Columns.Add(new DataColumn("ID", typeof(Int64)));
            dt.Columns.Add(new DataColumn("NAME", typeof(String)));
            dt.Columns.Add(new DataColumn("VALUE1", typeof(String)));
            DataRow dr = null;
            for (Int64 i = 0; i < 1000; i++)
            {
                dr = dt.NewRow();
                dr["ID"] = i;
                dr["NAME"] = "test_" + i;
                dr["VALUE1"] = "VALUE1_" + i;
                dt.Rows.Add(dr);
            }
            this.ultraGrid1.DataSource = dt;
        }

        private void InitializePrintPreviewControl()
        {
            this.ultraGridPrintDocument1.Grid = this.ultraGrid1;

            this.ultraGridPrintDocument1.FitWidthToPages = 1;
            this.ultraGridPrintDocument1.DefaultPageSettings.Margins.Top = 40;
            this.ultraGridPrintDocument1.DefaultPageSettings.Margins.Left = 40;
            this.ultraGridPrintDocument1.DefaultPageSettings.Margins.Right = 40;
            this.ultraGridPrintDocument1.DefaultPageSettings.Margins.Bottom = 40;

            this.ultraGridPrintDocument1.PageHeaderPrinting += new Infragistics.Win.Printing.HeaderFooterPrintingEventHandler(pageHeaderPrinting);
            
            this.ultraPrintPreviewControl1.Document = this.ultraGridPrintDocument1;

            this.ultraPrintPreviewControl1.Settings.Zoom = 1.00;
            this.ultraPrintPreviewControl1.UseAntiAlias = true;
            this.ultraPrintPreviewControl1.InvalidatePreview();

        }
        // SET ProcessBar
        public void SetProcessBar(int value)
        {
           this.ultraProgressBar1.Value = value;           
           Application.DoEvents();           
        }



        private void pageHeaderPrinting(object sender, Infragistics.Win.Printing.HeaderFooterPrintingEventArgs e)
        {         
            e.Handled = true;
            SetProcessBar(5 + e.Document.PageNumber*5);
            if (this.closeFlg)    // user close the form
            {
                e.Handled = false;                
                this.ultraPrintPreviewControl1.Refresh();
                return;
            }
        }

        private void ultraPrintPreviewControl1_PreviewGenerated(object sender, EventArgs e)
        {
            SetProcessBar(this.ultraProgressBar1.Maximum);
            this.ultraPanel1.Hide();
            this.button2.Enabled = true;
            this.processFlg = false;
        }
    }
}
